package java.rmi;

import java.io.IOException;
import java.io.PrintStream;
import java.io.PrintWriter;

public class RemoteException extends IOException {
   private static final long serialVersionUID = -5148567311918794206L;
   public Throwable detail;

   public RemoteException() {
   }

   public RemoteException(String var1) {
      super(var1);
   }

   public RemoteException(String var1, Throwable var2) {
      super(var1);
      this.detail = var2;
   }

   public String getMessage() {
      return this.detail == null ? super.getMessage() : super.getMessage() + "; nested exception is: \n\t" + this.detail.toString();
   }

   public void printStackTrace(PrintStream var1) {
      if (this.detail == null) {
         super.printStackTrace(var1);
      } else {
         synchronized(var1) {
            var1.println(this);
            this.detail.printStackTrace(var1);
         }
      }

   }

   public void printStackTrace() {
      this.printStackTrace(System.err);
   }

   public void printStackTrace(PrintWriter var1) {
      if (this.detail == null) {
         super.printStackTrace(var1);
      } else {
         synchronized(var1) {
            var1.println(this);
            this.detail.printStackTrace(var1);
         }
      }

   }
}
