package java.rmi.activation;

import java.io.Serializable;
import java.rmi.MarshalledObject;
import java.util.Properties;

public final class ActivationGroupDesc implements Serializable {
   private String className;
   private String location;
   private MarshalledObject data;
   private CommandEnvironment env;
   private Properties props;
   private static final long serialVersionUID = -4936225423168276595L;

   public ActivationGroupDesc(Properties var1, CommandEnvironment var2) {
      this((String)null, (String)null, (MarshalledObject)null, var1, var2);
   }

   public ActivationGroupDesc(String var1, String var2, MarshalledObject var3, Properties var4, CommandEnvironment var5) {
      this.props = var4;
      this.env = var5;
      this.data = var3;
      this.location = var2;
      this.className = var1;
   }

   public String getClassName() {
      return this.className;
   }

   public String getLocation() {
      return this.location;
   }

   public MarshalledObject getData() {
      return this.data;
   }

   public Properties getPropertyOverrides() {
      return this.props != null ? (Properties)this.props.clone() : null;
   }

   public CommandEnvironment getCommandEnvironment() {
      return this.env;
   }

   public boolean equals(Object var1) {
      if (var1 instanceof ActivationGroupDesc) {
         ActivationGroupDesc var2 = (ActivationGroupDesc)var1;
         return (this.className == null ? var2.className == null : this.className.equals(var2.className)) && (this.location == null ? var2.location == null : this.location.equals(var2.location)) && (this.data == null ? var2.data == null : this.data.equals(var2.data)) && (this.env == null ? var2.env == null : this.env.equals(var2.env)) && (this.props == null ? var2.props == null : this.props.equals(var2.props));
      } else {
         return false;
      }
   }

   public int hashCode() {
      return (this.location == null ? 0 : this.location.hashCode() << 24) ^ (this.env == null ? 0 : this.env.hashCode() << 16) ^ (this.className == null ? 0 : this.className.hashCode() << 8) ^ (this.data == null ? 0 : this.data.hashCode());
   }
}
