package java.rmi.server;

import java.io.OutputStream;
import java.io.PrintStream;
import java.security.AccessController;
import sun.rmi.transport.tcp.TCPTransport;
import sun.security.action.GetBooleanAction;

public abstract class RemoteServer extends RemoteObject {
   private static String logname = "RMI";
   private static LogStream log;
   private static final long serialVersionUID = -4100238210092549637L;

   protected RemoteServer() {
   }

   protected RemoteServer(RemoteRef var1) {
      super(var1);
   }

   public static String getClientHost() throws ServerNotActiveException {
      return TCPTransport.getClientHost();
   }

   public static void setLog(OutputStream var0) {
      if (var0 == null) {
         log = null;
      } else {
         LogStream var1 = LogStream.log(logname);
         var1.setOutputStream(var0);
         log = var1;
      }

   }

   public static PrintStream getLog() {
      return log;
   }

   static {
      try {
         Boolean var0 = (Boolean)AccessController.doPrivileged(new GetBooleanAction("java.rmi.server.logCalls"));
         boolean var1 = var0;
         log = var1 ? LogStream.log(logname) : null;
      } catch (Exception var2) {
      }

   }
}
